#include<chrono>
#include<functional>
#include<iostream>
namespace nanxing_test
{
    void time_test(std::function<void()> fun )
    {
        std::chrono::high_resolution_clock::time_point tp1 = std::chrono::high_resolution_clock::now();
        fun();
        std::chrono::high_resolution_clock::time_point tp2 = std::chrono::high_resolution_clock::now();
        std::chrono::duration<size_t, std::nano> dur = tp2 - tp1;
        std::cout << "1 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::nanoseconds>(dur).count() << " 纳秒" << std::endl;
        std::cout << "2 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::microseconds>(dur).count() << " 微妙" << std::endl;
        std::cout << "3 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::milliseconds>(dur).count() << " 毫秒" << std::endl;
        std::cout << "4 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::seconds>(dur).count() << " 秒钟" << std::endl;
        std::cout << "5 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::minutes>(dur).count() << " 分钟" << std::endl;
        std::cout << "6 被计时代码耗时：" << std::chrono::duration_cast<std::chrono::hours>(dur).count() << " 小时" << std::endl;
    }
}